import { __extends } from "tslib";
import { IgxAssigningSeriesShapeStyleEventArgsBase } from "./igx-assigning-series-shape-style-event-args-base";
import { AssigningCategoryStyleEventArgs as AssigningCategoryStyleEventArgs_internal } from "./AssigningCategoryStyleEventArgs";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `AssigningCategoryStyle` event fired to allow you to override the style of items in a category or financial series
*/
var IgxAssigningCategoryStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxAssigningCategoryStyleEventArgs, _super);
    function IgxAssigningCategoryStyleEventArgs() {
        return _super.call(this) || this;
    }
    IgxAssigningCategoryStyleEventArgs.prototype.createImplementation = function () {
        return new AssigningCategoryStyleEventArgs_internal();
    };
    Object.defineProperty(IgxAssigningCategoryStyleEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    return IgxAssigningCategoryStyleEventArgs;
}(IgxAssigningSeriesShapeStyleEventArgsBase));
export { IgxAssigningCategoryStyleEventArgs };
