import { IgxSeriesComponent } from "./igx-series-component";
import { CalloutStyleUpdatingEventArgs as CalloutStyleUpdatingEventArgs_internal } from "./CalloutStyleUpdatingEventArgs";
import { brushToString, stringToBrush } from "igniteui-angular-core";
var IgxCalloutStyleUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgxCalloutStyleUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxCalloutStyleUpdatingEventArgs.prototype.createImplementation = function () {
        return new CalloutStyleUpdatingEventArgs_internal();
    };
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgxCalloutStyleUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgxCalloutStyleUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "xValue", {
        get: function () {
            return this.i.xValue;
        },
        set: function (v) {
            this.i.xValue = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "yValue", {
        get: function () {
            return this.i.yValue;
        },
        set: function (v) {
            this.i.yValue = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "item", {
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "series", {
        get: function () {
            var r = this.i.series;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgxSeriesComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "background", {
        get: function () {
            return brushToString(this.i.background);
        },
        set: function (v) {
            this.i.background = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "textColor", {
        get: function () {
            return brushToString(this.i.textColor);
        },
        set: function (v) {
            this.i.textColor = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "outline", {
        get: function () {
            return brushToString(this.i.outline);
        },
        set: function (v) {
            this.i.outline = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "leaderBrush", {
        get: function () {
            return brushToString(this.i.leaderBrush);
        },
        set: function (v) {
            this.i.leaderBrush = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxCalloutStyleUpdatingEventArgs.prototype, "strokeThickness", {
        get: function () {
            return this.i.strokeThickness;
        },
        set: function (v) {
            this.i.strokeThickness = +v;
        },
        enumerable: false,
        configurable: true
    });
    return IgxCalloutStyleUpdatingEventArgs;
}());
export { IgxCalloutStyleUpdatingEventArgs };
