import { VerticalAnchoredCategorySeries } from "./VerticalAnchoredCategorySeries";
import { IBarSeries } from "./IBarSeries";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { SeriesVisibleRangeMode } from "./SeriesVisibleRangeMode";
import { Rect } from "igniteui-angular-core";
import { Point, Type } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class BarSeries extends VerticalAnchoredCategorySeries implements IBarSeries {
    static $t: Type;
    protected get_di(): boolean;
    protected gz(): number;
    protected get_d5(): boolean;
    protected by(): SeriesView;
    protected r7(): CategoryTransitionInMode;
    b4(): SeriesVisibleRangeMode;
    l4(a: SeriesView): void;
    vb: BarSeriesView;
    protected get_c3(): boolean;
    p3(a: Point): Rect;
    ez(a: Point, b: boolean): boolean;
    constructor();
    r3(a: CategorySeriesView): CategoryFramePreparer;
    ac(): void;
    vc: number;
    vd: number;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    k2(a: boolean, b: SeriesView): void;
    s0(): number;
    t1(a: CategorySeriesView): number;
    aq(a: Axis): AxisRange;
    eq(a: any): boolean;
    ge(): number;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    protected k5(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    getPreferredCategoryMode(): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BarBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: BarSeriesView);
    protected i: BarSeriesView;
    g(a: number): void;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class BarSeriesView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: BarSeries;
    constructor(a: BarSeries);
    db: Pool$1<Rectangle>;
    as(): void;
    di(): Rectangle;
    dc: List$1<Rectangle>;
    dd(a: Rectangle): void;
    df(a: Rectangle): void;
    de(a: Rectangle): void;
    dg(a: Rectangle, b: number, c: number): void;
    cs(): CategoryBucketCalculator;
    protected bf(a: any, b: number): void;
    protected ac(a: number): any;
    private dh;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
    protected af(): void;
}
