import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { AnnotationAppearanceMode } from "./AnnotationAppearanceMode";
import { DoubleCollection } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CrosshairLayer extends AnnotationLayer {
    static $t: Type;
    protected get_dc(): boolean;
    protected get_da(): boolean;
    constructor();
    protected by(): SeriesView;
    l4(a: SeriesView): void;
    protected td: CrosshairLayerView;
    vq: Brush;
    vr: Brush;
    t4: string;
    te: Series;
    tj: boolean;
    th: boolean;
    xAxisAnnotationFormatLabel: (item: any) => string;
    tf(): boolean;
    yAxisAnnotationFormatLabel: (item: any) => string;
    tg(): boolean;
    vu: Brush;
    vs: Brush;
    tm: number;
    ty: number;
    vt: Brush;
    get v0(): Thickness;
    to: number;
    tq: number;
    tp: number;
    tn: number;
    get v1(): Thickness;
    tu: number;
    tw: number;
    tv: number;
    tt: number;
    tr: number;
    vx: Brush;
    vv: Brush;
    ts: number;
    tz: number;
    vw: Brush;
    tx: number;
    v3: Visibility;
    v2: Visibility;
    ti: boolean;
    protected r3(a: Series, b: boolean): void;
    protected r5(a: Frame, b: SeriesView): void;
    protected qw(a: Series): boolean;
    lx(): void;
    protected qg(): AnnotationAppearanceMode;
    protected q3(): number;
    protected q6(): number;
    protected q5(): number;
    protected s2(): DoubleCollection;
    protected s3(): DoubleCollection;
    private vy;
    private vz;
    private uv;
    private tl;
    private tk;
    protected uw(a: CrosshairLayerFrame, b: boolean): void;
    private uu;
    protected r8(a: Frame, b: SeriesView): void;
    protected ep(): boolean;
    protected l9(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CrosshairLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CrosshairLayer);
    protected b4: CrosshairLayer;
    b5: Pool$1<Path>;
    protected b6: List$1<Path>;
    as(): void;
    private ce;
    private b7;
    private b9;
    private b8;
    ca(a: Path, b: number, c: number, d: number): void;
    cb(a: Brush, b: number): Brush;
    cd(a: Brush, b: number): Brush;
    cc(a: Brush, b: number): Brush;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
