import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point, Type } from "igniteui-angular-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { ScalerParams } from "./ScalerParams";
/**
 * @hidden
 */
export declare abstract class HorizontalRangeCategorySeries extends RangeCategorySeries {
    static $t: Type;
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    kz(): void;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected get_ee(): boolean;
    protected bq(): SeriesHitTestMode;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    hm(a: Point, b: boolean): number;
    ho(a: Point, b: boolean): number;
    f7(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    gn(a: Point, b: boolean, c: boolean): number;
    gl(a: Point, b: boolean, c: boolean): number;
    gj(a: Point, b: boolean, c: boolean): number;
    po(a: Point, b: boolean, c: boolean): Point;
    pq(a: Point, b: boolean, c: boolean): Point;
    ps(a: Point, b: boolean, c: boolean): Point;
    sr(): boolean;
    protected l9(a: any, b: string, c: any, d: any): void;
    t5(a: any): boolean;
    t4(a: any): boolean;
    ua: string;
    t6: string;
    uc: string;
    t8: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
