import { LegendBase } from "./LegendBase";
import { IChartItemLegend } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { LegendOrientation } from "./LegendOrientation";
import { LegendBaseView } from "./LegendBaseView";
import { Type } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { ILegendSeries } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { ILegendContext } from "igniteui-angular-core";
import { LegendVisualData } from "./LegendVisualData";
/**
 * @hidden
 */
export declare class ItemLegend extends LegendBase implements IChartItemLegend {
    static $t: Type;
    aj(): LegendBaseView;
    a8(a: LegendBaseView): void;
    bb: ItemLegendView;
    constructor();
    addChildInOrder(a: UIElement, b: ILegendSeries): void;
    protected get_isItemwise(): boolean;
    createItemwiseLegendItems(a: List$1<UIElement>, b: ILegendSeries): void;
    a0(a: List$1<UIElement>, b: ILegendSeries): void;
    createLegendItemsInsert(a: List$1<UIElement>, b: ILegendSeries): void;
    bj(a: List$1<UIElement>, b: ILegendSeries): void;
    renderItemwiseContent(a: ILegendSeries): void;
    bk(a: ILegendSeries): void;
    bf(a: ILegendSeries): number;
    private be;
    bd: IFastItemColumn$1<number>;
    get bc(): LegendOrientation;
    set bc(a: LegendOrientation);
    get bh(): string;
    set bh(a: string);
    get bi(): string;
    set bi(a: string);
}
/**
 * @hidden
 */
export declare class ItemLegendView extends LegendBaseView {
    static $t: Type;
    constructor(a: ItemLegend);
    ao: ItemLegend;
    ak(): void;
    protected get_j(): boolean;
    ap(a: ILegendContext): boolean;
    f(): LegendVisualData;
}
