import { HorizontalRangeCategorySeries } from "./HorizontalRangeCategorySeries";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { RangeCategorySeriesView } from "./RangeCategorySeriesView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class RangeAreaSeries extends HorizontalRangeCategorySeries {
    static $t: Type;
    protected by(): SeriesView;
    l4(a: SeriesView): void;
    um: RangeAreaSeriesView;
    protected get_dg(): boolean;
    protected get_df(): boolean;
    protected un(a: Point, b: Point, c: Point, d: boolean): boolean;
    ez(a: Point, b: boolean): boolean;
    constructor();
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    k2(a: boolean, b: SeriesView): void;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class RangeAreaSeriesView extends RangeCategorySeriesView {
    static $t: Type;
    protected c2: RangeAreaSeries;
    constructor(a: RangeAreaSeries);
    as(): void;
    private da;
    private c6;
    private db;
    get dc(): Polyline;
    get c7(): Polygon;
    get dd(): Polyline;
    c3(): void;
    c4(a: number, b: List$1<number[]>, c: boolean): void;
    private c9;
    private c8;
    private c5;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
