import { __extends } from "tslib";
import { IgxAssigningSeriesStyleEventArgsBase } from "./igx-assigning-series-style-event-args-base";
import { toDoubleCollection, fromDoubleCollection } from "igniteui-angular-core";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*/
var IgxAssigningSeriesShapeStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxAssigningSeriesShapeStyleEventArgsBase, _super);
    function IgxAssigningSeriesShapeStyleEventArgsBase() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "strokeThickness", {
        /**
         * Gets or sets stroke thickness to use for the current item.
        */
        get: function () {
            return this.i.t;
        },
        set: function (v) {
            this.i.t = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "strokeDashArray", {
        /**
         * Gets or sets stroke dash array to use for the current item.
        */
        get: function () {
            return fromDoubleCollection(this.i.u);
        },
        set: function (v) {
            this.i.u = toDoubleCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "radiusX", {
        /**
         * Gets or sets corner radius X to use for the current item, if applicable.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgxAssigningSeriesShapeStyleEventArgsBase.prototype, "radiusY", {
        /**
         * Gets or sets corner radius Y to use for the current item, if applicable.
        */
        get: function () {
            return this.i.s;
        },
        set: function (v) {
            this.i.s = +v;
        },
        enumerable: false,
        configurable: true
    });
    return IgxAssigningSeriesShapeStyleEventArgsBase;
}(IgxAssigningSeriesStyleEventArgsBase));
export { IgxAssigningSeriesShapeStyleEventArgsBase };
