import { __extends } from "tslib";
import { IgCollection } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
import { SyncableObservableCollection$2 } from "igniteui-angular-core";
import { TreemapNodeStyleMapping as TreemapNodeStyleMapping_internal } from './TreemapNodeStyleMapping';
import { IgxTreemapNodeStyleMappingComponent as IgxTreemapNodeStyleMappingComponent } from './igx-treemap-node-style-mapping-component';
var IgxTreemapNodeStyleMappingCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgxTreemapNodeStyleMappingCollection, _super);
    function IgxTreemapNodeStyleMappingCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxTreemapNodeStyleMappingComponent.$type) {
            IgxTreemapNodeStyleMappingComponent.$type = markType(IgxTreemapNodeStyleMappingComponent, "IgxTreemapNodeStyleMappingComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgxTreemapNodeStyleMappingCollection.prototype._createInnerColl = function () {
        if (!IgxTreemapNodeStyleMappingComponent.$type) {
            IgxTreemapNodeStyleMappingComponent.$type = markType(IgxTreemapNodeStyleMappingComponent, "IgxTreemapNodeStyleMappingComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxTreemapNodeStyleMappingComponent.$type, TreemapNodeStyleMapping_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgxTreemapNodeStyleMappingComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgxTreemapNodeStyleMappingCollection;
}(IgCollection));
export { IgxTreemapNodeStyleMappingCollection };
