import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class MovingAverageConvergenceDivergenceIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    static $t: Type;
    protected get_tw(): IndicatorDisplayType;
    constructor();
    protected get_up(): IndicatorCalculationStrategy;
    protected get up(): IndicatorCalculationStrategy;
    protected get_u2(): Type;
    protected get u2(): Type;
    get shortPeriod(): number;
    set shortPeriod(a: number);
    static readonly vd: DependencyProperty;
    protected ux(): number;
    get longPeriod(): number;
    set longPeriod(a: number);
    static readonly vc: DependencyProperty;
    protected uu(): number;
    get signalPeriod(): number;
    set signalPeriod(a: number);
    static readonly ve: DependencyProperty;
    protected t5(): number;
}
