import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { SplineType } from "./SplineType";
import { SeriesView } from "./SeriesView";
import { AxisRange } from "./AxisRange";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "igniteui-angular-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CollisionAvoider } from "./CollisionAvoider";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { NumericAxisBase } from "./NumericAxisBase";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    protected gz(): number;
    protected by(): SeriesView;
    l4(a: SeriesView): void;
    mt(a: boolean): void;
    vm: SplineSeriesBaseView;
    vo: boolean;
    aq(a: Axis): AxisRange;
    protected get_dg(): boolean;
    vj(a: CategorySeriesView): number[][];
    vk(a: CategorySeriesView): number[][];
    protected vl: number[];
    vz(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericAxisBase, f: CategorySeriesView): void;
    vp(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    tc(a: CategoryFrame, b: CategorySeriesView): void;
    vy(a: CategorySeriesView): void;
    private vs;
    gd(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    vt(a: CategoryAxisBase, b: Rect, c: Rect, d: Rect): number;
    private vr;
    protected get vv(): number;
    protected set vv(a: number);
    private vq;
    protected get vu(): number;
    protected set vu(a: number);
    vn: SplineType;
    protected v0(): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    protected k5(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SplineSeriesBaseView extends AnchoredCategorySeriesView {
    static $t: Type;
    protected da: SplineSeriesBase;
    constructor(a: SplineSeriesBase);
    db(): number;
    protected af(): void;
}
