import { Series } from "./Series";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Axis } from "./Axis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Type, Point } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { Geometry } from "igniteui-angular-core";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { RenderSurface } from "./RenderSurface";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ValueOverlay extends Series implements IHasCategoryModePreference {
    static $t: Type;
    constructor();
    qc: Axis;
    qv: number;
    qt: number;
    qu: number;
    qq: number;
    gn(a: Point, b: boolean, c: boolean): number;
    qr(a: Point, b: Point): number;
    ps(a: Point, b: boolean, c: boolean): Point;
    hi(a: Point): number;
    hy(a: Point): any;
    eq(a: any): boolean;
    aq(a: Axis): AxisRange;
    mo(a: boolean): void;
    qs(): number;
    rd(a: number, b: ValueOverlayView): void;
    fd(a: Rect, b: Rect, c: SeriesView): boolean;
    protected nb(a: Rect, b: Rect): void;
    protected na(a: Rect, b: Rect): void;
    protected k5(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    lk(): void;
    k2(a: boolean, b: SeriesView): void;
    private qh;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get categoryAxis(): CategoryAxisBase;
    protected by(): SeriesView;
    l4(a: SeriesView): void;
    private qf;
    mp(a: Rect, b: RenderSurface): void;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    qg: boolean;
    qe: (item: any) => string;
    rv: Brush;
    rt: Brush;
    qk: number;
    qw: number;
    ru: Brush;
    get rw(): Thickness;
    qm: number;
    qo: number;
    qn: number;
    ql: number;
    qp: number;
    ag(): Axis[];
    private qd;
    private qj;
    private qi;
    protected re(a: number, b: boolean): void;
    protected get_isValueOverlay(): boolean;
    q9(a: number): string;
    get rb(): string;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ValueOverlayView extends SeriesView {
    static $t: Type;
    constructor(a: ValueOverlay);
    private bz;
    protected bb(): void;
    protected bc(): void;
    by(a: Geometry): void;
    bx(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    al(a: any): void;
}
